// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function util_get_date(timestamp=0){
    let date = new Date(timestamp); // 创建一个日期对象
    return date.getFullYear()+'-'+(date.getMonth() + 1)+'-'+date.getDate();
}

function util_get_now_date(){
    let date = new Date(Date.now()); // 创建一个日期对象
    return date.getFullYear()+'-'+(date.getMonth() + 1)+'-'+date.getDate();
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function selectPhoneNumber(str) {
    const phoneReg = /(1[0-9]{10})|([0-9]{3,4})?[0-9]{7,12}/g;//匹配手机号或者固话
    const num = str.replace(/\s|[(]|[)]|[（]|[）]|[-]*/g, '');//去除字符串中所有空格、小括号和横杠
    const phone_arr = num.match(phoneReg);//识别手机号或者固话（在字符串内检索指定的值，或找到一个或多个正则表达式的匹配）
    let phone = '';
    if(phone_arr && phone_arr.length > 0){
        for(let i=0;i<phone_arr.length;i++){
            phone = phone_arr[i];
            if(phone.indexOf('86') != -1 || phone.indexOf('0755') != -1){
                break;
            }
        }
    }
    return phone;
}

function get_phone(str=''){
    var $html = $(str);
    let phone = '';
    $html.find('a').each(function (){
        let _ahref = $(this).attr('href');
        if(_ahref && (_ahref.indexOf('tel') != -1 || _ahref.indexOf('phone') != -1) &&
            _ahref.indexOf('www') ==-1 && _ahref.indexOf('hotel') ==-1 &&
            _ahref.indexOf('Intellectual') ==-1 &&
            _ahref.indexOf('Patel') ==-1
        ){
            phone = $(this).text();
        }
    });
    //td中的phone
    if(phone == '' || !phone){
        $html.find('table td').each(function (){
                let _td_val = $(this).text();
                if((_td_val.indexOf('+86')!=-1 ||
                    _td_val.indexOf('Hotline') != -1 ||
                    _td_val.indexOf('fax') != -1 ||
                    _td_val.indexOf('mobile') != -1 ||
                    _td_val.indexOf('0086')!=-1 ||
                    _td_val.indexOf('86-0755')!=-1 ||
                    _td_val.indexOf('0755')!=-1 ||
                    _td_val.indexOf('tel')!=-1 ||
                    _td_val.indexOf('whatsapp') != -1 ||
                    _td_val.indexOf('phone') != -1 ||
                    _td_val.indexOf('专线')!=-1) && (_td_val.indexOf('hotel') ==-1 &&
                    _td_val.indexOf('Intellectual') ==-1 &&
                    _td_val.indexOf('Patel') ==-1)
                ){
                    phone = _td_val;
                }
        });
    }
    //
    if(phone == '' || !phone){
       $html.find('p').each(function (){
           let _p_text = $(this).text();
           if((_p_text.indexOf('tel') != -1 ||
               _p_text.indexOf('Hotline') != -1 ||
               _p_text.indexOf('fax') != -1 ||
               _p_text.indexOf('mobile') != -1 ||
               _p_text.indexOf('+86')!=-1 ||
               _p_text.indexOf('0086')!=-1 ||
               _p_text.indexOf('86-0755')!=-1 ||
               _p_text.indexOf('0755')!=-1 ||
               _p_text.indexOf('whatsapp') != -1 ||
               _p_text.indexOf('phone') != -1 ||
               _p_text.indexOf('专线')!=-1) && (_p_text.indexOf('hotel') ==-1 &&
                    _p_text.indexOf('Intellectual') ==-1 &&
                    _p_text.indexOf('Patel') ==-1)
           ){
               phone = _p_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('li').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('span').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    //
    if(phone == '' || !phone){
       $html.find('div').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 ||
                    _div_text.indexOf('Intellectual') ==-1 ||
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
     //
    if(phone == '' || !phone){
        phone = $html.find('.phone').text();
    }
    //排除一些
    if(phone){
        //去一些字符
        phone = phone.replace('https://api.whatsapp.com/send?phone=','');
        phone = phone.replace('{','');
        phone = phone.replace('}','');
        phone = phone.replace('Mobile：','');
        phone = phone.replace('Tel: ','');
        phone = phone.replace('手机：','');
        if(phone.indexOf('click')!=-1 || phone.indexOf('font-size')!=-1){
            phone = '';
        }
    }

    return phone;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_domain_host(url=''){
    domain = util_url_get_domain(url);
    if(domain){
        domainArr = domain.split('.');
        if(domainArr.length>1){
           var domain_may = domainArr[1];
           if(domain_may.length>=5){
               return domain_may;
           }else{
               return domainArr[0];
           }
        }else if(domainArr.length==1){
            return domainArr[0];
        }
    }
    return '';
}

function get_seller_id_from_url(seller_url=''){
    //https://www.amazon.com/gp/help/seller/at-a-glance.html/ref=dp_merchant_link?ie=UTF8&seller=A265O6I0NWO52E&asin=B088N7GSV5&ref_=dp_merchant_link&isAmazonFulfilled=1
    let seller_id = '';
    let seller_url_arr = seller_url.split('&');
    for (let i=0;i<seller_url_arr.length;i++){
        if(seller_url_arr[i].indexOf('seller=') !=-1){
            seller_id = seller_url_arr[i].replace('seller=','');
            break;
        }
    }
    return seller_id;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}
//
function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}
//
function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}
//
function storage_shangjia_item_url_set(_shangjia_info={},local_num=1, callback){
    //
    if(typeof _shangjia_info['shangjia_item_url'] == 'undefined'){
        return;
    }
    if(_shangjia_info['shangjia_item_url'].indexOf('undefined') != -1){
        return;
    }
    //
    let _shangjia_item_url = _shangjia_info['shangjia_item_url'];
    let _shangjia_item_url_arr = _shangjia_item_url.split('?');
    let prefix = 'shangjia_shangjia_item_url_'+$.md5(_shangjia_item_url_arr[0]);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_item_url': _shangjia_info['shangjia_item_url'],
                '_is_request':0,
                //
                '_product_name': _shangjia_info['_product_name'],
                '_product_review_num': 0,
                '_product_review_score':0,
                '_product_bought_in_past_month':0,
                '_product_answered_questions':0,
                '_product_price':'',
                '_product_old_price':'',
                '_product_brand':'',
                '_product_img': '',
                '_product_bestseller_rank_name':'',
                '_product_bestseller_rank_top':'',
                '_product_bestseller_rank_url':'',
                '_product_add_date':'',
                //
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_id': '',
                '_seller_is_repeat': 0,
                '_seller_name':'',
                '_seller_url':'',
                '_seller_url_is_request':0,

                '_seller_about':'',
                '_seller_detail':'',
                '_seller_phone': '',
                'num':(total_add_shangjia_num+1)
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}
//
function request_shangjia_item_url_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _shangjia_item_url = need_item['_shangjia_item_url'];
        console.log('request_shangjia_item_url_ajax:'+_shangjia_item_url);
        let _shangjia_item_url_four_character = _shangjia_item_url.slice(0,4);
        if(_shangjia_item_url.indexOf('javascript')!=-1 || _shangjia_item_url_four_character !='http' || _shangjia_item_url.indexOf('amazon-adsystem') != -1){
            need_item['_seller_url_is_request'] = 2;
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        $.ajax({
            url:need_item['_shangjia_item_url']+'&psc=1',
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               /**
                '_is_request':0,
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_name':'',
                '_seller_url':'',
                '_seller_url_is_request':0,

                '_seller_about':'',
                '_seller_detail':''
                 */
               //
                let _shangjia_item_url = need_item['_shangjia_item_url']
                let current_url = _shangjia_item_url.replace('https://','');
                let current_url_arr = current_url.split('/');
                let current_amz_site = 'https://'+current_url_arr[0];
                //

                let _store_name = _dom.find('a#bylineInfo').text();
                _store_name = _store_name.replace('Visit the','');
                _store_name = _store_name.replace('Store','');
                _store_name = _store_name.trim();
                //
                need_item['_store_name'] = _store_name;
                //
                let _productTitle = _dom.find('#productTitle').text();
                //
                if(need_item['_store_name'] || _productTitle){
                    //
                    need_item['_store_url'] = current_amz_site+_dom.find('a#bylineInfo').attr('href');
                    //
                    let _shipping_from = _dom.find('.tabular-buybox-container .tabular-buybox-text:eq(1)').text();
                    _shipping_from = _shipping_from.trim();
                    if(_shipping_from){

                    }else{
                         _shipping_from  = _dom.find('#fulfillerInfoFeature_feature_div .offer-display-feature-text-message').text();
                    }
                    need_item['_shipping_from'] = _shipping_from;
                    _seller_name = _dom.find('a#sellerProfileTriggerId:eq(0)').text();
                    _seller_name = _seller_name.trim();
                    need_item['_seller_name'] = _seller_name;
                    //
                    let _seller_url = _dom.find('a#sellerProfileTriggerId:eq(0)').attr('href');
                    if(_seller_url){
                        need_item['_seller_url'] = current_amz_site+_seller_url;
                    }
                    //get seller id
                    need_item['_seller_id'] = get_seller_id_from_url(need_item['_seller_url']);
                    //
                    need_item['_product_name'] = _productTitle.trim();
                    let _product_review_num = _dom.find('#acrCustomerReviewText:eq(0)').text();
                    if(_product_review_num){
                        _product_review_num = _product_review_num.replace(',','').replace('ratings','');
                        _product_review_num = _product_review_num.trim();
                        need_item['_product_review_num'] = _product_review_num;
                    }
                    let _product_review_score = _dom.find('#acrPopover').attr('title');
                    if(_product_review_score){
                        _product_review_score = _product_review_score.replace('out of 5 stars','');
                        _product_review_score = _product_review_score.trim();
                        need_item['_product_review_score'] = _product_review_score;
                    }
                    //
                    let _product_answered_questions = _dom.find('#askATFLink').text();
                    if(_product_answered_questions){
                        _product_answered_questions = _product_answered_questions.replace('answered questions','');
                        _product_answered_questions = _product_answered_questions.trim();
                        need_item['_product_answered_questions'] = _product_answered_questions;
                    }
                    //
                    let _product_bought_in_past_month = _dom.find('#social-proofing-faceout-title-tk_bought').text();
                    if(_product_bought_in_past_month){
                        _product_bought_in_past_month = _product_bought_in_past_month.replace('bought in past month','');
                        _product_bought_in_past_month = _product_bought_in_past_month.trim();
                        need_item['_product_bought_in_past_month'] = _product_bought_in_past_month;
                    }
                    //
                    let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
                    let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
                    if(_product_price){
                        _product_price = _product_price.trim();
                        _product_price = _product_price.replace('$','');
                    }
                    if(_product_old_price){
                        _product_old_price = _product_old_price.trim();
                        _product_old_price = _product_old_price.replace('$','');
                    }
                    need_item['_product_price'] = _product_price;
                    need_item['_product_old_price'] = _product_old_price;
                    //
                    let _product_img = _dom.find('#imgTagWrapperId img').attr('src');
                    need_item['_product_img'] = _product_img;
                    //
                    let _product_bestseller_rank_name = '';
                    let _product_bestseller_rank_top= '';
                    //
                    _dom.find('#productDetails_detailBullets_sections1 tr').each(function (){
                        let _td_a = $(this).find('td a:eq(0)').attr('href');
                        if(_td_a && _td_a.indexOf('bestsellers')!=-1){
                            //
                            need_item['_product_bestseller_rank_url'] = current_amz_site+_td_a;
                            //
                           _dom.find('td span span').each(function (){
                                //
                                let _last_bestseller_rank = $(this).text();
                                if(_last_bestseller_rank.indexOf('in')!=-1 && _last_bestseller_rank.indexOf('#')!=-1 && _last_bestseller_rank.indexOf('(')==-1){
                                    _last_bestseller_rank = _last_bestseller_rank.trim();
                                    _last_bestseller_rank_arr = _last_bestseller_rank.split('in');
                                    if(_last_bestseller_rank_arr.length > 1){
                                        _product_bestseller_rank_name = _last_bestseller_rank_arr[1];
                                        _product_bestseller_rank_name = _product_bestseller_rank_name.trim();
                                        _product_bestseller_rank_top = _last_bestseller_rank_arr[0];
                                        _product_bestseller_rank_top = _product_bestseller_rank_top.trim();
                                        _product_bestseller_rank_top = _product_bestseller_rank_top.replace('#','').replace(',','');
                                    }
                                    return false;
                                    //
                                }
                                //
                           });
                            //
                        }
                    });
                    //
                    if(typeof _product_bestseller_rank_name == 'undefined' || _product_bestseller_rank_name == ''){
                        console.log('_product_bestseller_rank_name is empty');
                        //
                        _dom.find("#detailBulletsWrapper_feature_div > ul:eq(0) li").each(function (){
                            let _span_label = $(this).find('span.a-text-bold').text();
                            if(_span_label){
                                if(_span_label.indexOf('Best Sellers Rank')!=-1){
                                    _product_bestseller_rank_url = current_amz_site + $(this).find('ul li:eq(0) a').attr('href');
                                    need_item['_product_bestseller_rank_url'] = _product_bestseller_rank_url;
                                    _product_bestseller_rank_name = $(this).find('ul li:eq(0) a').text();
                                    //
                                    if(_product_bestseller_rank_name){
                                        _last_bestseller_rank = $(this).find('ul li:eq(0)').text();
                                        _last_bestseller_rank = _last_bestseller_rank.trim();
                                        _last_bestseller_rank_arr = _last_bestseller_rank.split('in');
                                        _product_bestseller_rank_top = _last_bestseller_rank_arr[0];
                                        if(_product_bestseller_rank_top){
                                            _product_bestseller_rank_top = _product_bestseller_rank_top.trim();
                                            _product_bestseller_rank_top = _product_bestseller_rank_top.replace('#','').replace(',','');
                                        }
                                    }
                                }
                            }
                        })
                        //
                    }
                    //
                    need_item['_product_bestseller_rank_name'] = _product_bestseller_rank_name;
                    need_item['_product_bestseller_rank_top'] = _product_bestseller_rank_top;
                    //
                    let _product_add_date = _dom.find('#productDetails_detailBullets_sections1 tr:last-child td.prodDetAttrValue').text();
                    if(typeof _product_add_date == 'undefined' || _product_add_date == ''){
                        _dom.find("#detailBullets_feature_div li").each(function (){
                            let _span_label = $(this).find('span.a-text-bold').text();
                            let _span_val = $(this).find('span.a-list-item span:eq(1)').text();
                            if(_span_label){
                                if(_span_label.indexOf('Date First Available')!=-1){
                                    _product_add_date = _span_val;
                                }
                            }
                        })
                    }
                    need_item['_product_add_date'] = _product_add_date;
                    //
                    _dom.find('#productOverview_feature_div table tr').each(function (){
                        let _td_1 = $(this).find('td:eq(0)').text();
                        if(_td_1 && _td_1.indexOf('Brand') != -1){
                            let _brand = $(this).find('td:eq(1)').text();
                            _brand = _brand.trim();
                            need_item['_product_brand'] = _brand;
                        }
                     });

                    //
                    need_item['_is_request'] = 2;
                    need_item['_seller_url_is_request'] = 2;
                    //
                    console.log('need_item');
                    console.log(need_item);
                    //
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });
                    //
                }else{
                    //查看是否是出现验证页了
                    let _g = _dom.find('#g').attr('id');
                    if(_g && _g == 'g'){
                        need_item['_is_request'] = 0;
                        pause_s_time();
                        sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    }else{
                        need_item['_is_request'] = 2;
                        need_item['_seller_url_is_request'] = 2;
                    }
                    //
                    need_item['_error'] = '';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });

                }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                console.log('jqXHR statue:'+jqXHR.status)
                //
                if(jqXHR.status == '404'){
                     need_item['_is_request'] = 2;
                     need_item['_seller_url_is_request'] = 2;
                }else{
                    need_item['_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    //
                }
            }
        });
        //
    })
}

function request_shangjia_item_url(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-8000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_item_url_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}
//
function request_shangjia_seller_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _seller_url = need_item['_seller_url'];
        console.log('request_shangjia_seller_link_ajax:'+_seller_url);
        let _seller_url_four_character = _seller_url.slice(0,4);
        if(_seller_url.indexOf('javascript')!=-1 || _seller_url_four_character!='http'){
            need_item['_seller_url_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        $.ajax({
            url:need_item['_seller_url'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               var $html = $(data);
               //
                /*
                _seller_about
                _seller_detail
                 */
               need_item['_seller_about'] = $html.find('#spp-expander-about-seller').text();
               if(need_item['_seller_about']){
                    let _seller_detail = $html.find('#page-section-detail-seller-info').text();
                   _seller_detail = _seller_detail.replace('Detailed Seller InformationBusiness Name:','');
                   _seller_detail = _seller_detail.trim();
                   need_item['_seller_detail'] = _seller_detail;
                   need_item['_seller_country'] = $html.find('#page-section-detail-seller-info .a-row:last-child').text();
                   need_item['_seller_phone'] = $html.find('#seller-contact-phone').text();
                   need_item['_seller_url_is_request'] = 2;
               }else{
                   //查看是否是出现验证页了
                    let _g = $html.find('#g').attr('id');
                    if(_g && _g == 'g'){
                        need_item['_seller_url_is_request'] = 0;
                        pause_s_time();
                        sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    }else{
                        need_item['_seller_url_is_request'] = 2;
                    }
               }

               let obj = {};
               obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
               });

               //
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_seller_url_is_request'] = 0;
                if(errorThrown == 'Not Found' || jqXHR.status == '404'){
                    need_item['_seller_url_is_request'] = 2;
                }
                //
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_seller_url']);
                }
            }
        });
        //
    })
}

function request_shangjia_seller_link(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 2 &&
                    (items[key]['_seller_url_is_request'] ==0 || (items[key]['_seller_url_is_request'] == 1 && items[key]['_seller_url_s_time'] < (Date.now()-8000))  )){
                    need_item = items[key];
                    need_item['_seller_url_is_request'] = 1;
                    need_item['_seller_url_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_seller_link_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function xintiao(){
    chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+5000) > Date.now()){
                 console.log('因出现人机验证，暂停一会');
             }else{
                 console.log('爬取中');
                 request_shangjia_item_url();
                // request_shangjia_seller_link();
             }
         }else{
             console.log('已暂停爬取');
         }
         //
         monitor_request_product();
         //
    });
    //
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });

}
xintiao();
setInterval(xintiao, 5000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_shangjia_item_url') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_seller_id') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'data_process'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_shangjia_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2 && items[key]['_seller_url_is_request'] == 2){
                    has_caiji_shangjia_num += 1;
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_shangjia_num': has_caiji_shangjia_num
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

/*monitor*/
function monitor_storage_product_set(_product_info={}, callback){
    //
    let prefix = 'monitor_product_'+$.md5(_product_info['_product_asin']);
    //
    chrome.storage.local.get(null, function(items) {
        let total_num = 0;
        for(let key in items){
            if(key.indexOf('monitor_product_') != -1){
                total_num += 1;
            }
        }
        total_num = total_num+1;
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            /**
             * _monitor_data:
             * '_product_review_num': '',
                '_product_review_score':'',
                '_product_bought_in_past_month':'',
                '_product_answered_questions':'',
                '_product_price':'',
                '_product_old_price':'',
                '_product_bestseller_rank_name':'',
                '_product_bestseller_rank_top':'',
                '_product_bestseller_rank_url':'',
                '_product_brand':'',
             *
             */
            obj[prefix] = {
                '_product_url': _product_info['_product_url'],
                '_product_name': _product_info['_product_name'],
                '_product_asin': _product_info['_product_asin'],
                '_product_img': '',
                //
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_id': '',
                '_seller_name':'',
                '_seller_url':'',
                'num':total_num,
                '_add_date':util_get_now_date(),
                '_s_time':0,
                '_last_request_date':0,
                '_is_request':0,
                //
                '_monitor_data': [],
                 //
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}
//
function monitor_request_product_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _product_url = need_item['_product_url'];
        console.log('monitor_request_product_ajax:'+_product_url);
        //
        $.ajax({
            url:need_item['_product_url']+'&psc=1',
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               /**
                '_is_request':0,
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_name':'',
                '_seller_url':'',
                '_seller_url_is_request':0,

                '_seller_about':'',
                '_seller_detail':''
                 */
               //
                let _shangjia_item_url = need_item['_product_url']
                let current_url = _shangjia_item_url.replace('https://','');
                let current_url_arr = current_url.split('/');
                let current_amz_site = 'https://'+current_url_arr[0];
                //

                let _store_name = _dom.find('a#bylineInfo').text();
                _store_name = _store_name.replace('Visit the','');
                _store_name = _store_name.replace('Store','');
                _store_name = _store_name.trim();
                //
                need_item['_store_name'] = _store_name;
                //
                let _productTitle = _dom.find('#productTitle').text();
                //
                if(need_item['_store_name'] || _productTitle){
                    //
                    need_item['_store_url'] = current_amz_site+_dom.find('a#bylineInfo').attr('href');
                    //
                    let _shipping_from = _dom.find('.tabular-buybox-container .tabular-buybox-text:eq(1)').text();
                    _shipping_from = _shipping_from.trim();
                    if(_shipping_from){

                    }else{
                         _shipping_from  = _dom.find('#fulfillerInfoFeature_feature_div .offer-display-feature-text-message').text();
                    }
                    need_item['_shipping_from'] = _shipping_from;
                    _seller_name = _dom.find('a#sellerProfileTriggerId:eq(0)').text();
                    _seller_name = _seller_name.trim();
                    need_item['_seller_name'] = _seller_name;
                    //
                    let _seller_url = _dom.find('a#sellerProfileTriggerId:eq(0)').attr('href');
                    if(_seller_url){
                        need_item['_seller_url'] = current_amz_site+_seller_url;
                    }
                    //get seller id
                    need_item['_seller_id'] = get_seller_id_from_url(need_item['_seller_url']);
                    //
                    need_item['_product_name'] = _productTitle.trim();
                    ////////////////////
                    let _monitor_data = {
                        '_product_review_num': '',
                        '_product_review_score':'',
                        '_product_bought_in_past_month':'',
                        '_product_answered_questions':'',
                        '_product_price':'',
                        '_product_old_price':'',
                        '_product_bestseller_rank_name':'',
                        '_product_bestseller_rank_top':'',
                        '_product_bestseller_rank_url':'',
                        '_product_brand':'',
                        '_date':''
                    }
                    //

                    let _product_review_num = _dom.find('#acrCustomerReviewText:eq(0)').text();
                    if(_product_review_num){
                        _product_review_num = _product_review_num.replace(',','').replace('ratings','');
                        _product_review_num = _product_review_num.trim();
                        _monitor_data['_product_review_num'] = _product_review_num;
                    }
                    let _product_review_score = _dom.find('#acrPopover').attr('title');
                    if(_product_review_score){
                        _product_review_score = _product_review_score.replace('out of 5 stars','');
                        _product_review_score = _product_review_score.trim();
                        _monitor_data['_product_review_score'] = _product_review_score;
                    }
                    //
                    let _product_answered_questions = _dom.find('#askATFLink').text();
                    if(_product_answered_questions){
                        _product_answered_questions = _product_answered_questions.replace('answered questions','');
                        _product_answered_questions = _product_answered_questions.trim();
                        _monitor_data['_product_answered_questions'] = _product_answered_questions;
                    }
                    //
                    let _product_bought_in_past_month = _dom.find('#social-proofing-faceout-title-tk_bought').text();
                    if(_product_bought_in_past_month){
                        _product_bought_in_past_month = _product_bought_in_past_month.replace('bought in past month','');
                        _product_bought_in_past_month = _product_bought_in_past_month.trim();
                        _monitor_data['_product_bought_in_past_month'] = _product_bought_in_past_month;
                    }
                    //
                    let _product_price = _dom.find('#corePriceDisplay_desktop_feature_div .reinventPricePriceToPayMargin:eq(0)').text();
                    let _product_old_price = _dom.find('#corePriceDisplay_desktop_feature_div:eq(0) .basisPrice:eq(0) .a-offscreen:eq(0)').text();
                    if(_product_price){
                        _product_price = _product_price.trim();
                        _product_price = _product_price.replace('$','');
                    }
                    if(_product_old_price){
                        _product_old_price = _product_old_price.trim();
                        _product_old_price = _product_old_price.replace('$','');
                    }
                    _monitor_data['_product_price'] = _product_price;
                    _monitor_data['_product_old_price'] = _product_old_price;

                    //
                    let _product_img = _dom.find('#imgTagWrapperId img').attr('src');
                    need_item['_product_img'] = _product_img;
                    //
                    //
                    let _product_bestseller_rank_name = '';
                    let _product_bestseller_rank_top= '';
                    let _product_bestseller_rank_url = '';
                    //
                    _dom.find('#productDetails_detailBullets_sections1 tr').each(function (){
                        let _td_a = $(this).find('td a:eq(0)').attr('href');
                        if(_td_a && _td_a.indexOf('bestsellers')!=-1){
                            //
                            _monitor_data['_product_bestseller_rank_url'] = current_amz_site+_td_a;
                            //
                           _dom.find('td span span').each(function (){
                                //
                                let _last_bestseller_rank = $(this).text();
                                if(_last_bestseller_rank.indexOf('in')!=-1 && _last_bestseller_rank.indexOf('#')!=-1 && _last_bestseller_rank.indexOf('(')==-1){
                                    _last_bestseller_rank = _last_bestseller_rank.trim();
                                    _last_bestseller_rank_arr = _last_bestseller_rank.split('in');
                                    if(_last_bestseller_rank_arr.length > 1){
                                        _product_bestseller_rank_name = _last_bestseller_rank_arr[1];
                                        _product_bestseller_rank_name = _product_bestseller_rank_name.trim();
                                        _product_bestseller_rank_top = _last_bestseller_rank_arr[0];
                                        _product_bestseller_rank_top = _product_bestseller_rank_top.trim();
                                        _product_bestseller_rank_top = _product_bestseller_rank_top.replace('#','').replace(',','');
                                    }
                                    return false;
                                    //
                                }
                                //
                           });
                            //
                        }
                    });
                    //
                    if(typeof _product_bestseller_rank_name == 'undefined' || _product_bestseller_rank_name == ''){
                        console.log('_product_bestseller_rank_name is empty');
                        //
                        _dom.find("#detailBulletsWrapper_feature_div > ul:eq(0) li").each(function (){
                            let _span_label = $(this).find('span.a-text-bold').text();
                            if(_span_label){
                                if(_span_label.indexOf('Best Sellers Rank')!=-1){
                                    _product_bestseller_rank_url = current_amz_site + $(this).find('ul li:eq(0) a').attr('href');
                                    _monitor_data['_product_bestseller_rank_url'] = _product_bestseller_rank_url;
                                    _product_bestseller_rank_name = $(this).find('ul li:eq(0) a').text();
                                    //
                                    if(_product_bestseller_rank_name){
                                        _last_bestseller_rank = $(this).find('ul li:eq(0)').text();
                                        _last_bestseller_rank = _last_bestseller_rank.trim();
                                        _last_bestseller_rank_arr = _last_bestseller_rank.split('in');
                                        _product_bestseller_rank_top = _last_bestseller_rank_arr[0];
                                        if(_product_bestseller_rank_top){
                                            _product_bestseller_rank_top = _product_bestseller_rank_top.trim();
                                            _product_bestseller_rank_top = _product_bestseller_rank_top.replace('#','').replace(',','');
                                        }
                                    }
                                }
                            }
                        })
                        //
                    }
                    //
                    _monitor_data['_product_bestseller_rank_name'] = _product_bestseller_rank_name;
                    _monitor_data['_product_bestseller_rank_top'] = _product_bestseller_rank_top;
                    //
                    _monitor_data['_date'] = util_get_now_date();
                    //
                    need_item['_monitor_data'].push(_monitor_data);
                    //
                    need_item['_is_request'] = 2;
                    need_item['_last_request_date'] = util_get_now_date()
                    //
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });
                    //
                }else{
                    //查看是否是出现验证页了
                    let _g = _dom.find('#g').attr('id');
                    if(_g && _g == 'g'){
                        need_item['_is_request'] = 1;
                        sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_product_url']);
                    }else{
                        need_item['_is_request'] = 2;
                    }
                    //
                    need_item['_error'] = '';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });

                }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                console.log('jqXHR statue:'+jqXHR.status)
                //
                if(jqXHR.status == '404'){
                     need_item['_is_request'] = 2;
                     need_item['_seller_url_is_request'] = 2;
                }else{
                    need_item['_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    //
                }
            }
        });
        //
    })
}
//
function monitor_request_product(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('monitor_product_') != -1){
                if(util_get_date(Date.now())!=items[key]['_last_request_date'] && (items[key]['_is_request']!=1 || (items[key]['_is_request'] ==1 && items[key]['_s_time'] < (Date.now()-8000))  )){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        monitor_request_product_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if(request.action == 'shangjia_item_url_update'){
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_item_url_set(shangjia_infos[i], (i+1), function (){

           });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_caiji'){
        console.log('can_caiji',request,sender,sendResponse);
        //
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause') || items['pause'] == 0){
                sendResponse(JSON.stringify({state:0}));
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'monitor_add'){
        //
        console.log('monitor_add',request,sender,sendResponse);
        let _product_info = request.product_info;
        //
        monitor_storage_product_set(_product_info, function (){
            //
            //
        });
        sendResponse(JSON.stringify({state:1}));
        return true;
    }
  }
);
function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */
